import type { QueryFunctionContext, QueryKey, UseInfiniteQueryOptions, UseInfiniteQueryReturnType } from '@tanstack/vue-query';
import { AppRoute, AppRouteMutation, ClientArgs, ClientInferRequest, PartialClientInferRequest } from '@ts-rest/core';
import { DataResponse, ErrorResponse } from './common';
export type DataReturnInfiniteQuery<TAppRoute extends AppRoute, TClientArgs extends ClientArgs> = (queryKey: QueryKey, args: (context: QueryFunctionContext<QueryKey>) => PartialClientInferRequest<TAppRoute, TClientArgs>, options?: UseInfiniteQueryOptions<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>, TAppRoute>) => UseInfiniteQueryReturnType<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>>;
export declare const getRouteUseInfiniteQuery: <TAppRoute extends AppRoute, TClientArgs extends ClientArgs>(route: TAppRoute, clientArgs: TClientArgs) => (queryKey: QueryKey, argsMapper: (context: QueryFunctionContext) => ClientInferRequest<AppRouteMutation, ClientArgs>, options?: UseInfiniteQueryOptions<TAppRoute["responses"]> | undefined) => UseInfiniteQueryReturnType<TAppRoute["responses"], unknown>;
