import { type QueryKey, type UseQueryReturnType, UseQueryOptions, QueryFunctionContext } from '@tanstack/vue-query';
import { AppRoute, AppRouteMutation, AreAllPropertiesOptional, ClientArgs, ClientInferRequest, PartialClientInferRequest } from '@ts-rest/core';
import { DataResponse, ErrorResponse } from './common';
export type DataReturnQuery<TAppRoute extends AppRoute, TClientArgs extends ClientArgs, TArgs = PartialClientInferRequest<TAppRoute, TClientArgs>> = AreAllPropertiesOptional<TArgs> extends true ? (queryKey: QueryKey, args?: (context: QueryFunctionContext<QueryKey>) => TArgs, options?: UseQueryOptions<TAppRoute>) => UseQueryReturnType<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>> : (queryKey: QueryKey, args: (context: QueryFunctionContext<QueryKey>) => TArgs, options?: UseQueryOptions<TAppRoute>) => UseQueryReturnType<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>>;
export declare const getRouteUseQuery: <TAppRoute extends AppRoute, TClientArgs extends ClientArgs>(route: TAppRoute, clientArgs: TClientArgs) => (queryKey: QueryKey, args?: ((context: QueryFunctionContext<QueryKey>) => ClientInferRequest<AppRouteMutation, ClientArgs>) | undefined, options?: UseQueryOptions<TAppRoute["responses"]> | undefined) => UseQueryReturnType<TAppRoute["responses"], unknown>;
